# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetServerUrlResult',
    'AwaitableGetServerUrlResult',
    'get_server_url',
    'get_server_url_output',
]

@pulumi.output_type
class GetServerUrlResult:
    """
    A collection of values returned by getServerUrl.
    """
    def __init__(__self__, id=None, server_url=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if server_url and not isinstance(server_url, str):
            raise TypeError("Expected argument 'server_url' to be a str")
        pulumi.set(__self__, "server_url", server_url)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="serverUrl")
    def server_url(self) -> str:
        return pulumi.get(self, "server_url")


class AwaitableGetServerUrlResult(GetServerUrlResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetServerUrlResult(
            id=self.id,
            server_url=self.server_url)


def get_server_url(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetServerUrlResult:
    """
    ## # get_server_url

    The `get_server_url` data source can be used to retrieve the CA server URL
    that the provider is currently configured for.

    ## Example

    The following example populates the `server_url` output with the currently
    configured CA server URL.

    ```python
    import pulumi
    import pulumi_acme as acme

    url = acme.get_server_url()
    pulumi.export("serverUrl", url.server_url)
    ```

    #### Argument Reference

    This data source takes no arguments.

    #### Attribute Reference

    The following attributes are exported:

    * `id`: the CA server URL that the provider is currently configured for.
    * `server_url`: the CA server URL that the provider is currently configured
      for. Same as `id`.
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('acme:index/getServerUrl:getServerUrl', __args__, opts=opts, typ=GetServerUrlResult).value

    return AwaitableGetServerUrlResult(
        id=pulumi.get(__ret__, 'id'),
        server_url=pulumi.get(__ret__, 'server_url'))


@_utilities.lift_output_func(get_server_url)
def get_server_url_output(opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetServerUrlResult]:
    """
    ## # get_server_url

    The `get_server_url` data source can be used to retrieve the CA server URL
    that the provider is currently configured for.

    ## Example

    The following example populates the `server_url` output with the currently
    configured CA server URL.

    ```python
    import pulumi
    import pulumi_acme as acme

    url = acme.get_server_url()
    pulumi.export("serverUrl", url.server_url)
    ```

    #### Argument Reference

    This data source takes no arguments.

    #### Attribute Reference

    The following attributes are exported:

    * `id`: the CA server URL that the provider is currently configured for.
    * `server_url`: the CA server URL that the provider is currently configured
      for. Same as `id`.
    """
    ...
